#!/usr/bin/env python3
#
# author: Claudio Driussi
#
# thanks to: https://stackoverflow.com/questions/16698935/how-to-transform-an-xml-file-using-xslt-in-python
#
import lxml.etree as ET
import sys


def save_html(file_xml, file_xsl, file_html):
    dom = ET.parse(file_xml)
    xslt = ET.parse(file_xsl)
    transform = ET.XSLT(xslt)
    newdom = transform(dom)
    with open(file_html, 'w') as f:
        s = ET.tostring(newdom, pretty_print=True)
        if sys.version_info[0] > 2:
            s = str(s, 'utf-8')
        f.write(s)
        f.close()


if __name__ == '__main__':
    file_xml = 'print_fpa.xml'
    file_xsl = 'FoglioStileAssoSoftware.xsl'
    file_html = 'fattura_elettronica.html'

    if len(sys.argv) > 1:
        file_xml = sys.argv[1]

    if len(sys.argv) > 2:
        file_xsl = sys.argv[2]

    if len(sys.argv) > 3:
        file_html = sys.argv[3]

    save_html(file_xml, file_xsl, file_html)
