import sys
import time
import serial

class csImpText(object):

    def __init__(self, key):
        self.key = key

    def load_file(self, file):
        f = open(file,'r')
        l = f.readlines()
        f.close()
        l = [i.strip('\n') for i in l]
        self.load_list(l)

    def load_list(self, l):
        self.data = []
        rec = {}
        for i in l:
            if i.find(self.key) == 0:
                if rec:
                    self.data.append(rec)
                    rec = {}
            else:
                t = i.split(':')
                if len(t) > 2:
                    rec[t[0].strip()] = t[2]
                pass
        if rec:
            self.data.append(rec)


class Rcf(object):

    def __init__(self, port):
        self.debug = False
        self.prz_unit = True
        self.rep = {}
        self.msg_cortesia = None
        self.tender = None

        self.ser = serial.Serial(port)
        self.ser.xonxoff = True
        #self.ser.baudrate = 19200
        time.sleep(0.5)

    def rcf_out(self, data):
        if type(data).__name__=='str':
            imp = csImpText('*** VENDITA ***')
            imp.load_file(data)
            data = imp.data
        for rec in data:
            s = '"%s"%sH%s' % (rec['DESCRIZ'], rec['TOTROW'], self.rep.get(rec['TOTROW'],'1R') )
            self.send(s)
            if self.prz_unit and float(rec['QTA']) <> 1.0:
                s = '" (%s X %s)"@' % (rec['QTA'],rec['PRUNIT'],)
                self.send(s)           
            
    def send(self, s):
        if self.debug:
            print s
        else:
            print s
            self.ser.write(s)
            time.sleep(0.1)

    def close(self):
        if self.msg_cortesia:
            self.send('"%s"@40F' % (self.msg_cortesia,))
        if self.tender:
            self.send(self.tender)
##        self.send('""@')
        self.ser.close()


if __name__ == '__main__':
    file_in = 'C:\\CS\\VENDITA.TMP'
    if len(sys.argv) > 1:
        file_in = sys.argv[1]

    rcf = Rcf("COM3:") # 0 = COM1
#    rcf = Rcf("socket://192.168.0.111:1470") # 0 = COM1

    rcf.rep['21'] = '1R'
    rcf.rep['20'] = '1R'
    rcf.rep['10'] = '1R'
    rcf.rep['4'] = '1R'

##    rcf.tender = '1T' # contanti
    rcf.tender = '=' # subtotale
##    rcf.debug = True

    rcf.rcf_out(file_in)
    rcf.close()
